#include <sourcemod>
#include <sdktools>
#include <cstrike>
#include <sdkhooks>
#include <colorvariables>

#pragma semicolon 1

// Define
#define PLUGIN_VERSION "1.6.1"
#define FUN_RANDOM 1
#define FUN_QUEUE 2
#define	MAX_WEAPON_SLOTS 6
#define	MAX_WEAPON_STRING 80
#define GG_SLOTINDEX_KNIFE 2

// Ints
int roundstart;
int m_flNextSecondaryAttack = -1;
int Second;
int g_laser;
int alert;
int alivect, alivet;
int g_round_interval;
int g_round_interval1;
int g_Queue = 0;
int g_Weapon;
int pluginsfound = 0;
int counter = 0,counter2 = 0;

// Beacon
int  tid = 0;
int  ctid = 0;
int g_BeaconSerial[MAXPLAYERS+1] = { 0, ... };
int g_BeamSprite        = -1;
int g_HaloSprite        = -1;
int g_Serial_Gen = 0;
int redColor[4]		= {255, 75, 75, 255};
int greenColor[4]	= {75, 255, 75, 255};
int blueColor[4]	= {75, 75, 255, 255};
int greyColor[4]	= {128, 128, 128, 255};
char g_BlipSound[PLATFORM_MAX_PATH];

// Bools
bool BhopRound;
bool AwpRound;
bool KnifeRound;
bool ZeusRound;
bool DeagleRound;
bool ScoutRound;
bool NegavRound;
bool AkRound;
bool ShotgunRound;
bool AutoSniperRound;
bool NadeRound;
bool RevolverRound;
bool SpecialRound;
bool g_bulletpath;
bool PlayersCheck;
bool RandomRiflesRound;
bool RandomPistolsRound;
bool RandomSmgsRound;
bool RandomShotgunRound;
bool ShieldRound;
bool g_Zoom[MAXPLAYERS+1];

// stats
int kills[MAXPLAYERS+1];
int hs[MAXPLAYERS+1];
int knives[MAXPLAYERS+1];
int hits[MAXPLAYERS+1];
int grenade[MAXPLAYERS];
float damage1[MAXPLAYERS+1];

// Convars
ConVar sFunRoundsEnabled;
ConVar sEnableSound;
ConVar sRoundInterval;
ConVar sEnabledKnife;
ConVar sEnabledAwp;
ConVar sEnabledZeus;
ConVar sEnabledDeagle;
ConVar sEnabledScout;
ConVar sEnabledNegav;
ConVar sEnabledShotgun;
ConVar sEnabledAutoSniper;
ConVar sEnabledAK;
ConVar sEnabledBhop;
ConVar sEnabledNade;
ConVar sEnabledRevolver;
ConVar sEnableAlert;
ConVar sRemoveNewPlayer;
ConVar sEnableStats;
ConVar sFreezeTime;
ConVar sRoundType;
ConVar sAllowKnife;
ConVar sBulletTracers;
ConVar sBuyZone;
ConVar sFallDamage;
ConVar sUnLoadPlugin;
ConVar sInfiniteAmmo;
ConVar sDissolve;
ConVar sArmor;
ConVar sBeacon;
ConVar sMinPlayers;
ConVar sRandomRifles;
ConVar sRandomPistols;
ConVar sRandomSmgs;
ConVar sRandomShotgun;
ConVar sSelfDamage;
ConVar sHealthShot;
ConVar sShield;

char plugins[30][64];
char g_plugins[64];
char rifles[13][] = {
    "weapon_m4a1", "weapon_m4a1_silencer", "weapon_ak47", "weapon_aug", "weapon_awp", "weapon_famas",
    "weapon_G3SG1", "weapon_galilar", "weapon_m249", "weapon_negev", "weapon_scar20", "weapon_sg556", "weapon_ssg08"
};
char smgs[7][] = {
    "weapon_mp5sd", "weapon_bizon", "weapon_ump45", "weapon_mac10", "weapon_mp7", "weapon_mp9", "weapon_p90"
};
char pistols[10][] = {
    "weapon_deagle", "weapon_elite", "weapon_fiveseven", "weapon_glock", "weapon_hkp2000", "weapon_usp_silencer",
    "weapon_revolver", "weapon_p250", "weapon_cz75a", "weapon_tec9"
};
char shotgun[4][] = {
    "weapon_mag7", "weapon_nova", "weapon_sawedoff", "weapon_xm1014"
};
ArrayList g_activeRoundList;
EngineVersion g_Game;

public Plugin myinfo = 
{
	name = "[CSGO] SLAYER Funrounds",
	author = "SLAYER",
	description = "Funrounds comes after some rounds",
	version = PLUGIN_VERSION,
	url = "https://forums.alliedmods.net/member.php?u=293943"
};

public void OnPluginStart()
{
	g_Game = GetEngineVersion();
	if(g_Game != Engine_CSGO)
	{
		SetFailState("This plugin is for CSGO only.");
	}
	CreateConVar("funrounds_version", PLUGIN_VERSION, "Funrounds by SLAYER plugin version. Please don't change me!", FCVAR_REPLICATED|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	sFunRoundsEnabled = CreateConVar("funrounds_enabled", "1", "Enable/disable Funrounds by SLAYER plugin. (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnableSound = CreateConVar("funrounds_sounds", "1", "Enable/Disable the sounds of Special Rounds (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sRoundInterval = CreateConVar("funrounds_interval", "2", "Set number of rounds between a Fun/Special round (0=Everyround will be funround)", FCVAR_NOTIFY);
	sRoundType = CreateConVar("funrounds_type", "2", "Special Rounds Comes Randomly or in Queue (1-Random, 2 - Queue)", FCVAR_NOTIFY);
	sEnabledKnife = CreateConVar("funrounds_knife", "1", "Enabled/Disabled Knife Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnabledAwp = CreateConVar("funrounds_noscope", "1", "Enabled/Disabled Awp Noscope Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnabledZeus = CreateConVar("funrounds_zeus", "1", "Enabled/Disabled Zeus Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnabledDeagle = CreateConVar("funrounds_deagle", "1", "Enabled/Disabled Deagle Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnabledScout = CreateConVar("funrounds_scout", "1", "Enabled/Disabled Scout Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnabledNegav = CreateConVar("funrounds_negav", "1", "Enabled/Disabled Negav Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnabledShotgun = CreateConVar("funrounds_shotgun", "1", "Enabled/Disabled Shotgun Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnabledAutoSniper = CreateConVar("funrounds_autosniper", "1", "Enabled/Disabled Gaygun Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnabledAK = CreateConVar("funrounds_ak", "1", "Enabled/Disabled AK-47 Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnabledBhop = CreateConVar("funrounds_bhop", "1", "Enabled/Disabled Bhop Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnabledNade = CreateConVar("funrounds_nade", "1", "Enabled/Disabled Nade Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sRandomPistols = CreateConVar("funrounds_pistols", "1", "Enabled/Disabled Random Pistols Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sRandomRifles = CreateConVar("funrounds_rifles", "1", "Enabled/Disabled Random Rifles Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sRandomSmgs = CreateConVar("funrounds_smgs", "1", "Enabled/Disabled Random Smgs Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sRandomShotgun = CreateConVar("funrounds_shotguns", "1", "Enabled/Disabled Random Shotguns Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnabledRevolver = CreateConVar("funrounds_revolver", "1", "Enabled/Disabled Revolver Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sEnableAlert = CreateConVar("funrounds_alert", "1", "Enabled/Disabled Alert Message Comes before Special Round! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sRemoveNewPlayer = CreateConVar("funrounds_remove_new_player", "0", "Remove player connected when Special Round is started. (0 - Slay, 1 - Move to spec)", FCVAR_NOTIFY); // get from knife fight plugin
	sEnableStats = CreateConVar("funrounds_stats", "1", "Enabled/Disabled Stats Comes after special round end! (Mvp, Winner, Headshot kills, Knife kills, Total Damage Given, etc) (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY);
	sBulletTracers = CreateConVar("funrounds_tracers", "1", "Enabled/Disabled Bullet Tracers in Special Round (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sAllowKnife = CreateConVar("funrounds_allow_knife", "1", "Disable Knife in Special Round? (0 = No, 1 = Yes)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sFreezeTime = CreateConVar("funrounds_freezetime", "2", "Entre your default Freezetime of the Server(mp_freezetime)", FCVAR_NOTIFY);
	sBuyZone = CreateConVar("funrounds_buyzone", "0", "Enabled/Disabled Buy Zone in Special Round (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sFallDamage = CreateConVar("funrounds_fall_damage", "0", "Enabled/Disabled Fall Damage in Special Round (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sSelfDamage = CreateConVar("funrounds_self_damage", "0", "Enabled/Disabled Self Damage in Special Round. Useful in Nade Round (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sUnLoadPlugin = CreateConVar("funrounds_unload_plugins", "weapon_restrict.smx;abner_duel.smx;zeustracers.smx", "Unload Plugins On Special Round Starts!(Example: weapon_restrict.smx;abner_duel.smx | Note : The plugins will automatically load on special ends which are unloaded on special rounds starts)", FCVAR_NOTIFY);
	sInfiniteAmmo = CreateConVar("funrounds_infinite_ammo", "1", " Enabled/Disabled Infinite Ammo in Special Round!(0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sDissolve = CreateConVar("funrounds_dissolve", "1", " Enabled/Disabled Dissolve Player Body in Special Round!(0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sArmor = CreateConVar("funrounds_armor", "0", " Give Armor to Players in Special Round!(0 = NO, 1 = YES)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sShield = CreateConVar("funrounds_shield", "1", "Enabled/Disabled Negav+Riot Shield Round comes in Funrounds! (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sBeacon = CreateConVar("funrounds_beacon", "1", "Enabled/Disabled Beacon when 1vs1 player alive in Special Round!(0 = NO, 1 = YES)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sMinPlayers = CreateConVar("funrounds_minplayers", "3", "Minimum number of players then Special Round Starts!", FCVAR_NOTIFY);
	sHealthShot = CreateConVar("funrounds_healthshot", "1", "Give Player HealthShot in Special Round!(0 = NO, 1 = YES)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	m_flNextSecondaryAttack = FindSendPropInfo("CBaseCombatWeapon", "m_flNextSecondaryAttack");
	g_Weapon = FindSendPropInfo("CBaseCombatWeapon", "m_hOwnerEntity");
	AddCommandListener(OnJoinTeam, "jointeam");
	HookEvent("round_end", Event_OnRoundEnd, EventHookMode_PostNoCopy);
	HookEvent("round_start", Event_RoundStart, EventHookMode_PostNoCopy);
	HookEvent("bullet_impact", OnBulletImpact, EventHookMode_Post);	
	HookEvent("player_spawn", OnPlayerSpawn, EventHookMode_Post);
	HookEvent("weapon_fire", Event_WeaponFire);
	HookEvent("player_hurt", Event_PlayerHurt);
	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("hegrenade_detonate", GrenadeDetonate);
	HookConVarChange(sFunRoundsEnabled, OnConvarChanged);HookConVarChange(sEnabledKnife, OnConvarChanged);
	HookConVarChange(sEnabledAwp, OnConvarChanged);HookConVarChange(sEnabledZeus, OnConvarChanged);
	HookConVarChange(sEnabledDeagle, OnConvarChanged);HookConVarChange(sEnabledScout, OnConvarChanged);
	HookConVarChange(sEnabledNegav, OnConvarChanged);HookConVarChange(sEnabledShotgun, OnConvarChanged);
	HookConVarChange(sEnabledAutoSniper, OnConvarChanged);HookConVarChange(sEnabledAK, OnConvarChanged);
	HookConVarChange(sEnabledBhop, OnConvarChanged);HookConVarChange(sEnabledNade, OnConvarChanged);
	HookConVarChange(sRandomPistols, OnConvarChanged);HookConVarChange(sRandomRifles, OnConvarChanged);
	HookConVarChange(sRandomShotgun, OnConvarChanged);HookConVarChange(sRandomSmgs, OnConvarChanged);
	HookConVarChange(sEnabledRevolver, OnConvarChanged);HookConVarChange(sBulletTracers, OnConvarChanged);
	HookConVarChange(sAllowKnife, OnConvarChanged);HookConVarChange(sEnableAlert, OnConvarChanged);
	HookConVarChange(sBuyZone, OnConvarChanged);HookConVarChange(sFallDamage, OnConvarChanged);
	HookConVarChange(sInfiniteAmmo, OnConvarChanged);HookConVarChange(sDissolve, OnConvarChanged);
	HookConVarChange(sArmor, OnConvarChanged);HookConVarChange(sBeacon, OnConvarChanged);
	HookConVarChange(sMinPlayers, OnConvarChanged);HookConVarChange(sFreezeTime, OnConvarChanged);
	HookConVarChange(sEnableStats, OnConvarChanged);HookConVarChange(sSelfDamage, OnConvarChanged);
	HookConVarChange(sHealthShot, OnConvarChanged);HookConVarChange(sShield, OnConvarChanged);
	FilterActiveRounds();
	AutoExecConfig(true, "SLAYER_Funrounds");
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsClientInGame(i) && IsPlayerAlive(i) && IsClientConnected(i))
		{
			SDKHook(i, SDKHook_OnTakeDamage, OnTakeDamage);
		}
	}
}
public void OnConfigsExecuted()
{
	GetConVarString(sUnLoadPlugin, g_plugins, sizeof(g_plugins));
	if(!StrEqual(g_plugins, "", false))
	{
		pluginsfound = ExplodeString(g_plugins, ";", plugins, 30, 64);
	}
}
public void OnMapStart() // reseting all values on map start
{
	BhopRound = false;
	ZeusRound = false;
	ScoutRound = false;
	AwpRound = false;
	KnifeRound = false;
	SpecialRound = false;
	NegavRound = false;
	NadeRound = false;
	RevolverRound = false;
	AkRound = false;
	ShotgunRound = false;
	DeagleRound = false;
	PlayersCheck = false;
	ShieldRound = false;
	g_bulletpath = true;
	g_Queue = 0;
	g_round_interval = -1;
	g_round_interval1 = -1;
	//Beacon Stuff
	Handle gameConfig = LoadGameConfigFile("funcommands.games");
	if (gameConfig == null)
	{
		SetFailState("Unable to load game config funcommands.games");
		return;
	}
	if (GameConfGetKeyValue(gameConfig, "SoundBlip", g_BlipSound, sizeof(g_BlipSound)) && g_BlipSound[0])
	{
		PrecacheSound(g_BlipSound, true);
	}
	char buffer[PLATFORM_MAX_PATH];
	if (GameConfGetKeyValue(gameConfig, "SpriteBeam", buffer, sizeof(buffer)) && buffer[0])
	{
		g_BeamSprite = PrecacheModel(buffer);
	}
	if (GameConfGetKeyValue(gameConfig, "SpriteHalo", buffer, sizeof(buffer)) && buffer[0])
	{
		g_HaloSprite = PrecacheModel(buffer);
	}
	delete gameConfig;
	DownloadableContent();
	char file[] = "addons/sourcemod/translations/funrounds_by_slayer.phrases.txt";
	if(!FileExists(file)){SetFailState("Translation File Not Found!");}
	else{LoadTranslations("funrounds_by_slayer.phrases");}
}
public OnClientPutInServer(client) // kill player connect during special round
{
    SDKHook(client, SDKHook_OnTakeDamage, OnTakeDamage);
}
// Reset player stats on player disconnect
public Event_PlayerDisconnect(Handle event, const char[] name, bool dontBroadcast)
{
	int attacker = GetClientOfUserId(GetEventInt(event, "userid"));
	kills[attacker] = 0;
	hs[attacker] = 0;
	knives[attacker] = 0;
	damage1[attacker] = 0.0;
	hits[attacker] = 0;
	grenade[attacker] = 0;
}
public Action OnWeaponCanUse(int client, int iWeapon)  
{
	return Plugin_Handled;
}  
public Action OnPlayerRunCmd(client, &buttons, &impulse, float vel[3], float angles[3], &weapon)
{
	if(SpecialRound && AwpRound || AutoSniperRound) // Check Round is Special round and round is Noscope Round
	{
		if (IsClientInGame(client) && IsPlayerAlive(client)) // Check Player is Alive
		{
			char weaponname[32];
			GetClientWeapon(client, weaponname, sizeof(weaponname));
			// Check Weapons are Snipers
			if( StrEqual(weaponname, "weapon_ssg08") || StrEqual(weaponname, "weapon_scout")
			 || StrEqual(weaponname, "weapon_sg556") || StrEqual(weaponname, "weapon_awp")
			 || StrEqual(weaponname, "weapon_scar20") || StrEqual(weaponname, "weapon_g3sg1"))
			{
			    if(!g_Zoom[client] && buttons & IN_ATTACK2) // Check Client right click mouse button
			    {
			    	// Then print to Chat on right click mouse button press
			        CPrintToChat(client, "%t {orchid}You {darkred}can't {gold}Scope {orchid}in {lime}NoScope Round{darkred}!","Tag");
			        g_Zoom[client] = true;
			    }
			    else if(g_Zoom[client] && !(buttons & IN_ATTACK2))
			    {
			        g_Zoom[client] = false;
				}
			}
		}
	}
}
// Add tracers in Special Round
public OnBulletImpact(Handle event,const char[] name,bool dontBroadcast)
{
	if(sBulletTracers.BoolValue)
	{
		if (g_bulletpath && SpecialRound == true && !BhopRound)
		{
			int client = GetClientOfUserId(GetEventInt(event, "userid"));
			char weaponname[32];
			GetClientWeapon(client, weaponname, sizeof(weaponname));
			int color[4];
			// Check if Team is CT
			if (GetClientTeam(client) == 3){color = {75, 75, 255, 255};}
			// or T
			else{color = {255, 75, 75, 255};}
			float bulletOrigin[3];
			GetClientEyePosition(client, bulletOrigin);
			float bulletDestination[3];
			bulletDestination[0] = GetEventFloat(event, "x");
			bulletDestination[1] = GetEventFloat(event, "y");
			bulletDestination[2] = GetEventFloat(event, "z");
			TE_SetupBeamPoints(bulletOrigin, bulletDestination, g_laser, 0, 0, 0, 0.5, 1.0, 1.0, 10, 0.0, color, 0);
			TE_SendToAll(); 
		}
	}
}
void KillBeacon(int client)
{
	if (IsClientInGame(client) && IsPlayerAlive(client))
	{
		SetEntityRenderColor(client, 255, 255, 255, 255);
	}
}
void KillAllBeacons()
{
	for (int i = 1; i <= MaxClients; i++)
	{
		KillBeacon(i);
	}
}
void CreateBeacon(int client)
{
	g_BeaconSerial[client] = ++g_Serial_Gen;
	CreateTimer(1.0, StartBeacon, client | (g_Serial_Gen << 7), TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);	
}
public Action StartBeacon(Handle timer, any value)
{
	if (sBeacon.BoolValue && SpecialRound && !BhopRound)
	{
		int client = value & 0x7f;
		int serial = value >> 7;
		if (!IsClientInGame(client)
		|| !IsPlayerAlive(client)
		|| g_BeaconSerial[client] != serial)
		{
			KillBeacon(client);
			return Plugin_Stop;
		}
		int team = GetClientTeam(client);
		float vec[3];
		GetClientAbsOrigin(client, vec);
		vec[2] += 10;
		if (g_BeamSprite > -1 && g_HaloSprite > -1)
		{
			TE_SetupBeamRingPoint(vec, 10.0, 375.0, g_BeamSprite, g_HaloSprite, 0, 15, 0.5, 5.0, 0.0, greyColor, 10, 0);
			TE_SendToAll();
			
			if (team == 2)
			{
				TE_SetupBeamRingPoint(vec, 10.0, 375.0, g_BeamSprite, g_HaloSprite, 0, 10, 0.6, 10.0, 0.5, redColor, 10, 0);
			}
			else if (team == 3)
			{
				TE_SetupBeamRingPoint(vec, 10.0, 375.0, g_BeamSprite, g_HaloSprite, 0, 10, 0.6, 10.0, 0.5, blueColor, 10, 0);
			}
			else
			{
				TE_SetupBeamRingPoint(vec, 10.0, 375.0, g_BeamSprite, g_HaloSprite, 0, 10, 0.6, 10.0, 0.5, greenColor, 10, 0);
			}
			
			TE_SendToAll();
		}
		if (g_BlipSound[0])
		{
			GetClientEyePosition(client, vec);
			EmitAmbientSound(g_BlipSound, vec, client, SNDLEVEL_RAIDSIREN);	
		}
	}
	else if(!SpecialRound)
	{
		KillAllBeacons();
		return Plugin_Stop;
	}
	return Plugin_Continue;
}
public Action OnJoinTeam(int client, const char[] command, int args)
{
    if(SpecialRound && roundstart == 1 && !BhopRound)
    {
        CreateTimer(0.1, KillPlayer, client);
        return;
    }
}
public Action WeaponPickup(Handle timer)
{
	for(int i = 1; i < MaxClients; i++)
	{
		if(IsClientInGame(i) && IsPlayerAlive(i) && !IsFakeClient(i))
		{
			if(!BhopRound && !NadeRound){SDKHook(i, SDKHook_WeaponCanUse, OnWeaponCanUse);}
		}
	}
}
// On player Spwan
public OnPlayerSpawn(Handle event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(SpecialRound && AwpRound || AutoSniperRound) // Enable Noscope in Awp and AutoSniperRound
	{
		SDKHook(client, SDKHook_PreThink, OnPreThink);
	}
	else
	{
		SDKUnhook(client, SDKHook_PreThink, OnPreThink);
	}
	if(sArmor.BoolValue && SpecialRound && !BhopRound && IsClientInGame(client) && IsPlayerAlive(client))
	{
		SetEntProp(client, Prop_Send, "m_bHasHelmet", 1);
		SetEntProp(client, Prop_Send, "m_ArmorValue", 100);
	}
	if(NegavRound && SpecialRound)
	{
		if(IsClientInGame(client) && IsPlayerAlive(client))
		{
			if(NegavRound)SetEntityHealth(client, 1000); // Giving 1000 HP in negav Round
		}
	}
}
public void Event_RoundStart(Handle event, const char[] name, bool dontBroadcast)
{
	if(sFunRoundsEnabled.BoolValue) // check plugin is enabled or disabled
	{
		ctid = 0, tid = 0, Second = 3, roundstart = 1, counter = 0,counter2 = 0;
		for(new i = 1; i < MAXPLAYERS; i++) // reset stats
		{
			kills[i] = 0, hs[i] = 0,knives[i] = 0,damage1[i] = 0.0,hits[i] = 0, grenade[i] = 0;
		}
		if(sEnableAlert.BoolValue) // Show ALERT message before the special round
		{
			if(sRoundInterval.IntValue != 0)alert = sRoundInterval.IntValue-1;
			else alert = sRoundInterval.IntValue;
			if(alert == g_round_interval1)
			{
				if(sRoundInterval.IntValue != 0)g_round_interval1 = -2;
				else{g_round_interval1 = 0;}
				CPrintToChatAll("%t {darkred}Alert: {purple}Next {orchid}Round {purple}will be {green}Special Round{darkred}!!!", "Tag");
			}
		}
		if((ClientCount() < sMinPlayers.IntValue) && PlayersCheck)
		{
			CPrintToChatAll("%t {darkred}Not Enough {orchid}Players to Start {green}Special Round! {orchid}Special Round {darkred}Canceled","Tag");
			PlayersCheck = false;
		}
		if(SpecialRound == true)
		{
			CreateTimer(0.5, TimerCount, _, TIMER_REPEAT);
			if(!BhopRound)RemoveAllWeapons();
			if (BhopRound == false)CreateTimer(1.0, RemoveWeapon); // remove player weapons in special round except BHOP Round
			if(!BhopRound)CreateTimer(2.0, GiveWeapons); // Giving Weapons to Players
			if(!BhopRound)CreateTimer(10.0, WeaponPickup);
			if(!BhopRound)buyzone(); 
		}
	}
}
public void Event_OnRoundEnd(Handle event, const char[] name, bool dontBroadcast)
{
	if(sFunRoundsEnabled.BoolValue)// Check plugin is Enable or Disable in ConVar
	{
		int client = GetClientOfUserId(GetEventInt(event, "userid"));
		int WinningTeam = GetEventInt(event, "winner"); // get winning team
		roundstart = 0, ctid = 0, tid = 0, counter2 = 0;
		char Winner[20];
		if(WinningTeam == 3){Winner = "Counter-Terrorist";}
		if(WinningTeam == 2){Winner = "Terrorist";}
		int noob = 0, mostkills = 0, mosths = 0, mostknives = 0, mostgrenades = 0;
		if(sRoundInterval.IntValue != 0)g_round_interval1++;
		else g_round_interval1 = 0;
		if(sRoundInterval.IntValue != 0)g_round_interval++;
		else g_round_interval = 0;
		for(new i = 1; i < MaxClients; i++) // Get kills, headshots and knife kills
		{
			if(IsClientInGame(i) && kills[i] > 0)
			{
				if(kills[i] > kills[mostkills] || kills[i] == kills[mostkills] && damage1[i] > damage1[mostkills])
				{
					mostkills = i;
				}
				if(hs[i] > 0 && (hs[i] > hs[mosths] || hs[i] == hs[mosths]))
				{
					mosths = i;
				}
				if(knives[i] > 0 && (knives[i] > knives[mostknives] || knives[i] == knives[mostknives]))
				{
					mostknives = i;
				}
				if(grenade[i] > 0 && (grenade[i] > grenade[mostgrenades] || grenade[i] == grenade[mostgrenades]))
				{
					mostgrenades = i;
				}
			}
			else if(IsClientInGame(i) && kills[i] <= 0 && mostkills <= 0 && mosths <= 0 && mostknives <= 0 && damage1[i] <= 0)
			{
				noob = i;
			}
		}
		if(SpecialRound == true)
		{
			SpecialRound = false;
			SDKUnhook(client, SDKHook_WeaponCanUse, OnWeaponCanUse);
			int freezetime = sFreezeTime.IntValue;
			ServerCommand("mp_freezetime %d", freezetime);// Change Freezetime as written in Convar
			GetConVarString(sUnLoadPlugin, g_plugins, sizeof(g_plugins));
			if(!BhopRound)
			{
				for (new i = 0; i <= pluginsfound -1; i++)
				{
					if (pluginsfound > 0)
					{
						ServerCommand("sm plugins load %s", plugins[i]);
					}
				}
			}
			counter = 0;
			counter2 = 0;
			if(!BhopRound)RemoveAllWeapons();
			if(!BhopRound)CreateTimer(0.1, RemoveWeapon, _, TIMER_REPEAT);// Player dont get free weapon in next round
			if(!BhopRound)CreateTimer(0.3, RemoveArmor, _, TIMER_REPEAT);
			if(!BhopRound)CreateTimer(0.3, Unhook, _, TIMER_REPEAT);
			buyzone(); 
			// Show Round End text of Specific Round and turn of special round
			if(AutoSniperRound && roundstart == 0){AutoSniperEndText();AutoSniperRound = false;SDKUnhook(client, SDKHook_PreThink, OnPreThink);BhopOff();}
			if(ShotgunRound && roundstart == 0){ShotgunEndText();ShotgunRound = false;}
			if(AwpRound && roundstart == 0){AwpEndText();AwpRound = false;SDKUnhook(client, SDKHook_PreThink, OnPreThink);BhopOff();}
			if(KnifeRound && roundstart == 0){KnifeEndText();KnifeRound = false;BhopOff();}
			if(ZeusRound && roundstart == 0){ZeusEndText();ZeusRound = false;BhopOff();}
			if(DeagleRound && roundstart == 0) { DeagleEndText(); DeagleRound = false;}
			if(ScoutRound && roundstart == 0){ScoutEndText();ScoutRound = false;}
			if(AkRound && roundstart == 0){AKEndText();AkRound = false;}
			if(NegavRound && roundstart == 0){NegavEndText();NegavRound = false;}
			if(NadeRound && roundstart == 0){NadeEndText();NadeRound = false;}
			if(BhopRound && roundstart == 0){BhopEndText();BhopRound = false;BhopOff();}
			if(RevolverRound && roundstart == 0){RevolverEndText();RevolverRound = false;}
			if(RandomPistolsRound && roundstart == 0){PistolsEndText();RandomPistolsRound = false;}
			if(RandomSmgsRound && roundstart == 0){SmgsEndText();RandomSmgsRound = false;}
			if(RandomShotgunRound && roundstart == 0){ShotgunsEndText();RandomShotgunRound = false;}
			if(RandomRiflesRound && roundstart == 0){RiflesEndText();RandomRiflesRound = false;}
			if(ShieldRound && roundstart == 0){ShieldEndText();ShieldRound = false;}
			if(sEnableSound.BoolValue){
				for (new i = 1; i <= MaxClients; i++){ // play Sound to all players on Special Round End
			    	if(IsClientInGame(i) && IsClientConnected(i)){
			    		ClientCommand(i, "play slayer/Funrounds/round_end.mp3");}}}
			// Show Special Round Stats At the End of Round
			if(sEnableStats.BoolValue) // Check Stats is Enable or Disable in Convar
			{
				char noobname[MAX_NAME_LENGTH];
				GetClientName(noob, noobname, sizeof(noobname));// Get the Noob player name
				char mvpname[MAX_NAME_LENGTH];
				GetClientName(mostkills, mvpname, sizeof(mvpname));// Get the most kills name
				char hname[MAX_NAME_LENGTH];
				GetClientName(mosths, hname, sizeof(hname)); // Get the headshot killer name
				char kname[MAX_NAME_LENGTH];
				GetClientName(mostknives, kname, sizeof(kname)); // Get the knife killer name
				char Gname[MAX_NAME_LENGTH];
				GetClientName(mostgrenades, Gname, sizeof(Gname));
				CPrintToChatAll("%t", "Stats");
				CPrintToChatAll("{lime}★ {darkred}Winner {orchid}: {green}%s", Winner);
				if(mostkills > 0)CPrintToChatAll("{lime}★ {green}%s {orchid}is {gold}MVP {orchid}with {green}%i {darkred}Kills {orchid}by Giving {yellow}Damage {green}%0.0f {orchid}in {green}%i {purple}Hits", mvpname, kills[mostkills], damage1[mostkills], hits[mostkills]);
				if(mosths > 0)CPrintToChatAll("{lime}★ {gold}Most headshot kills {orchid}: {green}%s {gold}({lime}%i{gold})", hname, hs[mosths]);
				if(mostknives > 0)CPrintToChatAll("{lime}★ {yellow}Most Knife kills {orchid}: {green}%s {yellow}({lime}%i{yellow})", kname, knives[mostknives]);
				if(mostgrenades > 0)CPrintToChatAll("{lime}★ {purple}Most Grenade kills {orchid}: {lime}%s {purple}({lime}%i{purple})", Gname, grenade[mostgrenades]); // Most Grenades Kills in Round by which player
				if(noob == 0)CPrintToChatAll("{lime}★ {purple}Noob of the Round {orchid}: {green}%s", noobname);
				CPrintToChatAll("%t", "Stats");
			}
		}
	}
	if(sFunRoundsEnabled.IntValue == 1 && sRoundInterval.IntValue > -1 && g_round_interval == sRoundInterval.IntValue)// Check plugin is Enable or Disable in ConVar
	{
				PlayersCheck = true;
				if(sRoundInterval.IntValue != 0)g_round_interval = -1;
				else g_round_interval = 0;
				if((ClientCount() >= sMinPlayers.IntValue))
				{
					PlayersCheck = false;
					SpecialRound = true; // True Special Round
					ServerCommand("mp_freezetime 3"); // Change Special Round freezetime to 3
					if(g_activeRoundList.Length <= 0)// Check if any round is active in list
					{
						SetFailState("There are no Special Rounds which are active in cfg. Please activate any Special Round in cfg.");
						return; // Stop function because no round is active in list
					}
					// Select round either in Queue or randomly.
					char cRoundName[32]; // Variable to store round name
					switch(sRoundType.IntValue) // Check Round Type in ConVar
				    {
				        case FUN_RANDOM:
				        {
				            // Select any random round from active round list
				            // 0 denotes first element of the list, and g_activeRoundList.Length-1 denotes last element
							int RandomRound = GetRandomInt(0, g_activeRoundList.Length-1);
							g_activeRoundList.GetString(RandomRound, cRoundName, sizeof(cRoundName));
				        }
				        case FUN_QUEUE:
				        {
				            // Select round name in Queue
				            g_activeRoundList.GetString(g_Queue, cRoundName, sizeof(cRoundName));
				            g_Queue++;
				            // If current round is last element of list, then start from 0 (first round) again
				            if(g_Queue == g_activeRoundList.Length)
				            {
				                g_Queue = 0;
				            }
				        }
				    }
					if(StrEqual(cRoundName, "Round_Deagle")){PerformDeagleRound();}
					else if(StrEqual(cRoundName, "Round_Awp")){PerformAwpRound();}
					else if(StrEqual(cRoundName, "Round_Zeus")){PerformZeusRound();}
					else if(StrEqual(cRoundName, "Round_AK")){PerformAKRound();}
					else if(StrEqual(cRoundName, "Round_Nade")){PerformNadeRound();}
					else if(StrEqual(cRoundName, "Round_Knife")){PerformKnifeRound();}
					else if(StrEqual(cRoundName, "Round_Bhop")){PerformBhopRound();}
					else if(StrEqual(cRoundName, "Round_Shotgun")){PerformShotgunRound();}
					else if(StrEqual(cRoundName, "Round_AutoSniper")){PerformAutoSniperRound();}
					else if(StrEqual(cRoundName, "Round_Revolver")){PerformRevolverRound();}
					else if(StrEqual(cRoundName, "Round_Scout")){PerformScoutRound();}
					else if(StrEqual(cRoundName, "Round_Negav")){PerformNegavRound();}
					else if(StrEqual(cRoundName, "Round_Pistols")){PerformPistolsRound();}
					else if(StrEqual(cRoundName, "Round_Rifles")){PerformRiflesRound();}
					else if(StrEqual(cRoundName, "Round_Shotguns")){PerformShotgunsRound();}
					else if(StrEqual(cRoundName, "Round_Smgs")){PerformSmgsRound();}
					else if(StrEqual(cRoundName, "Round_Shield")){PerformShieldRound();}
					GetConVarString(sUnLoadPlugin, g_plugins, sizeof(g_plugins));
					if(!BhopRound)
					{
						for (new i = 0; i <= pluginsfound -1; i++)
						{
							if (pluginsfound > 0)
							{
								ServerCommand("sm plugins unload %s", plugins[i]);
							}
						}
					}
				}
	}
}
public Action TimerCount(Handle timer, any:client)
{
	if(!SpecialRound)
	{
		return Plugin_Stop;
	}
	if (Second  == 0) // When freezetime End
	{
		if(SpecialRound && roundstart == 1)
		{
			if(sEnableSound.BoolValue)
			{
				for (new i = 1; i <= MaxClients; i++)// Play Specific Sound to all players on specific Special Round
				{
			    	if (IsClientInGame(i) && IsClientConnected(i))
			    	{
			    		
							if(AwpRound == true)ClientCommand(i, "play slayer/Funrounds/awp.mp3");
							if(KnifeRound == true)ClientCommand(i, "play slayer/Funrounds/knife.mp3");
							if(BhopRound == true)ClientCommand(i, "play slayer/Funrounds/bhop.mp3");
							if(ZeusRound == true)ClientCommand(i, "play slayer/Funrounds/zeus.mp3");
							if(DeagleRound == true)ClientCommand(i, "play slayer/Funrounds/deagle.mp3");
							if(ScoutRound == true)ClientCommand(i, "play slayer/Funrounds/scout.mp3");
							if(AkRound == true)ClientCommand(i, "play slayer/Funrounds/ak.mp3");
							if(NegavRound == true)ClientCommand(i, "play slayer/Funrounds/machinegun.mp3");
							if(NadeRound == true)ClientCommand(i, "play slayer/Funrounds/nade.mp3");
							if(AutoSniperRound == true)ClientCommand(i, "play slayer/Funrounds/autosniper.mp3");
							if(ShotgunRound == true)ClientCommand(i, "play slayer/Funrounds/shotgun.mp3");
							if(RevolverRound == true)ClientCommand(i, "play slayer/Funrounds/revolver.mp3");
							if(RandomPistolsRound == true)ClientCommand(i, "play slayer/Funrounds/randompistols.mp3");
							if(RandomRiflesRound == true)ClientCommand(i, "play slayer/Funrounds/randomrifles.mp3");
							if(RandomSmgsRound == true)ClientCommand(i, "play slayer/Funrounds/randomsmgs.mp3");
							if(RandomShotgunRound == true)ClientCommand(i, "play slayer/Funrounds/randomshotguns.mp3");
							if(ShieldRound == true)ClientCommand(i, "play slayer/Funrounds/shield.mp3");
					}
			    }
			}
			// Show Text in Chat and in Hint which round is start
			if(AwpRound == true){AwpStartText();BhopOn();}
			if(KnifeRound == true){KnifeStartText();BhopOn();}
			if(BhopRound == true){BhopStartText();BhopOn();}
			if(ZeusRound == true){ZeusStartText();BhopOn();}
			if(DeagleRound == true){DeagleStartText();}
			if(ScoutRound == true){ScoutStartText();}
			if(AkRound == true){AKStartText();}
			if(AutoSniperRound == true){AutoSniperStartText();BhopOn();}
			if(ShotgunRound == true){ShotgunStartText();}
			if(NegavRound == true){NegavStartText();}
			if(NadeRound == true){NadeStartText();}
			if(RevolverRound == true){RevolverStartText();}
			if(RandomPistolsRound == true){PistolsStartText();}
			if(RandomRiflesRound == true){RiflesStartText();}
			if(RandomShotgunRound == true){ShotgunsStartText();}
			if(RandomSmgsRound == true){SmgsStartText();}
			if(ShieldRound == true){ShieldStartText();}
			CreateTimer(15.0, Message, _, TIMER_REPEAT);
			CreateTimer(12.0, MessageHint, _, TIMER_REPEAT);
			return Plugin_Stop;
		}
	}
	Second--;
	PrintHintTextToAll("<font color='#3DB1FF'>Special Round Starts in :</font> <font color='#FF0000'>%d</font>", Second);
	return Plugin_Continue;
}
// Noscope
public Action OnPreThink(client)
{
	SetNoScope(GetPlayerWeaponSlot(client, 0));
}
stock SetNoScope(weapon)
{
	if (IsValidEdict(weapon))
	{
		char classname[MAX_NAME_LENGTH];
		if (GetEdictClassname(weapon, classname, sizeof(classname))
			 || StrEqual(classname[7], "ssg08") || StrEqual(classname[7], "aug")
			 || StrEqual(classname[7], "sg550") || StrEqual(classname[7], "sg552")
			 || StrEqual(classname[7], "sg556") || StrEqual(classname[7], "awp")
			 || StrEqual(classname[7], "scar20") || StrEqual(classname[7], "g3sg1"))
		{
			SetEntDataFloat(weapon, m_flNextSecondaryAttack, GetGameTime() + 1.0);
		}
	}
}
// Show Warning message on weapon drop
public Action CS_OnCSWeaponDrop(client, weapon)
{
	char weapon_name[30];
	GetClientWeapon(client,weapon_name,30);
	ReplaceString(weapon_name, 30, "weapon_", "");	
	if(roundstart == 1 && SpecialRound && !BhopRound && !NadeRound && !ZeusRound)
	{
		CPrintToChat(client,"%t %t", "Tag", "ondrop", weapon_name);
		return Plugin_Stop;
	}
	return Plugin_Continue;
}
public Action GiveWeapons(Handle timer) // give specific weapons on specific Special Round On start of round
{
	if(roundstart == 0)return Plugin_Stop;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && IsPlayerAlive(i))
		{
			if(roundstart == 1)
			{
				if(ZeusRound){GivePlayerItem(i, "weapon_taser");if(sHealthShot.BoolValue){GivePlayerItem(i, "weapon_healthshot");}}
				if(DeagleRound){GivePlayerItem(i, "weapon_deagle");if(sHealthShot.BoolValue){GivePlayerItem(i, "weapon_healthshot");}}
				if(ScoutRound){GivePlayerItem(i, "weapon_ssg08");if(sHealthShot.BoolValue){GivePlayerItem(i, "weapon_healthshot");}}
				if(AwpRound){GivePlayerItem(i, "weapon_awp");if(sHealthShot.BoolValue){GivePlayerItem(i, "weapon_healthshot");}}
				if(NegavRound){GivePlayerItem(i, "weapon_negev");if(sHealthShot.BoolValue){GivePlayerItem(i, "weapon_healthshot");}}
				if(AkRound){GivePlayerItem(i, "weapon_ak47");if(sHealthShot.BoolValue){GivePlayerItem(i, "weapon_healthshot");}}
				if(NadeRound){GivePlayerItem(i, "weapon_hegrenade");if(sHealthShot.BoolValue){GivePlayerItem(i, "weapon_healthshot");}}
				if(ShotgunRound){GivePlayerItem(i, "weapon_nova");if(sHealthShot.BoolValue){GivePlayerItem(i, "weapon_healthshot");}}
				if(RevolverRound){GivePlayerItem(i, "weapon_revolver");if(sHealthShot.BoolValue){GivePlayerItem(i, "weapon_healthshot");}}
				if(ShieldRound){GivePlayerItem(i, "weapon_negev");GivePlayerItem(i, "weapon_shield");if(sHealthShot.BoolValue){GivePlayerItem(i, "weapon_healthshot");}}
				if(AutoSniperRound)
				{
					int clientTeam = GetClientTeam(i);
					if(clientTeam == 2)
					{
						GivePlayerItem(i, "weapon_g3sg1");
						if(sHealthShot.BoolValue)GivePlayerItem(i, "weapon_healthshot");
					}
					if(clientTeam == 3)
					{
						GivePlayerItem(i, "weapon_scar20");
						if(sHealthShot.BoolValue)GivePlayerItem(i, "weapon_healthshot");
					}
				}
				if(RandomShotgunRound)
				{
					int Random = GetRandomInt(0, 3);
					GivePlayerItem(i, shotgun[Random]);
					if(sHealthShot.BoolValue)GivePlayerItem(i, "weapon_healthshot");
				}
				if(RandomSmgsRound)
				{
					int Random = GetRandomInt(0, 6);
					GivePlayerItem(i, smgs[Random]);
					if(sHealthShot.BoolValue)GivePlayerItem(i, "weapon_healthshot");
				}
				if(RandomPistolsRound)
				{
					int Random = GetRandomInt(0, 9);
					GivePlayerItem(i, pistols[Random]);
					if(sHealthShot.BoolValue)GivePlayerItem(i, "weapon_healthshot");
				}
				if(RandomRiflesRound)
				{
					int Random = GetRandomInt(0, 12);
					GivePlayerItem(i, rifles[Random]);
					if(sHealthShot.BoolValue)GivePlayerItem(i, "weapon_healthshot");
				}
			}
		}
	}
	return Plugin_Continue;
}
public Action Unhook(Handle timer)
{
	if(counter2 == 5)
	{
		return Plugin_Stop;
	}
	for(int i = 1; i < MaxClients; i++)
	{
		if(IsClientInGame(i) && IsPlayerAlive(i) && !IsFakeClient(i))
		{
			SDKUnhook(i, SDKHook_WeaponCanUse, OnWeaponCanUse);
		}
	}
	counter2++;
	return Plugin_Continue;
}
public Action RemoveArmor(Handle timer)
{
	if(roundstart == 1)
	{
		return Plugin_Stop;
	}
	for(int i = 1; i < MaxClients; i++)
	{
		if(IsClientInGame(i) && IsPlayerAlive(i))
		{
			SetEntProp(i, Prop_Data, "m_ArmorValue", 0);
		}
	}
	return Plugin_Continue;
}
public Action RemoveWeapon(Handle timer)// remove player weapons on round start
{
	for(int i = 1; i < MaxClients; i++)
	{
		if(IsClientInGame(i) && IsPlayerAlive(i))
		{
			StripWeaponsButKnife(i);
		}
	}
	counter++;
	if(counter == 10)
	{
		return Plugin_Stop;
	}
	return Plugin_Continue;
}
// Strip all weapons but knife
stock void StripWeaponsButKnife(int iClient)
{
	int iSlot;
	for(int i = 0; i < 5; i++)
    {
        if(i == GG_SLOTINDEX_KNIFE)
        {
            continue; // You can leave your knife ON
        }
        // Strip all weapons from current slot
        iSlot = GetPlayerWeaponSlot(iClient, i);
        if(iSlot != -1)
        {
            RemovePlayerItem(iClient, iSlot);
            AcceptEntityInput(iSlot, "kill");
        }
    }
}
// Disable BUY ZONE in Special Round So no one buy any weapon during Special Round
buyzone()
{
	if(!sBuyZone.BoolValue&& !BhopRound)
	{
		int ent = MaxClients+1;
		if(roundstart == 1 && SpecialRound)
		{
			while((ent = FindEntityByClassname(ent, "func_buyzone")) !=-1 )
			{
				AcceptEntityInput(ent, "Disable");
			}
		}
		if(roundstart == 0 && !SpecialRound)
		{
			while((ent = FindEntityByClassname(ent, "func_buyzone")) !=-1 )
			{
				AcceptEntityInput(ent, "Enable");
			}
		}

	}
}
// give another zeus on fire
public Action Event_WeaponFire(Handle hEvent, const char[] sName, bool bDontBroadCast)
{
	int client = GetClientOfUserId(GetEventInt(hEvent, "userid"));
	char weaponname[32];
	GetClientWeapon(client, weaponname, sizeof(weaponname));
	if(SpecialRound && ZeusRound && roundstart == 1)
	{
		if (StrEqual(weaponname, "weapon_taser", false))
		{
	    	CreateTimer(1.0, GiveItem, client, TIMER_FLAG_NO_MAPCHANGE);
	    }
	}
	if(SpecialRound && !ZeusRound && !KnifeRound && !BhopRound && roundstart ==1) // Unlimited Ammos in Special Round
	{
		if(sInfiniteAmmo.BoolValue)
		{
			int weapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
			if(weapon > 0 && (weapon == GetPlayerWeaponSlot(client, CS_SLOT_PRIMARY) || weapon == GetPlayerWeaponSlot(client, CS_SLOT_SECONDARY)))
			{
				SetEntProp(weapon, Prop_Send, "m_iPrimaryReserveAmmoCount", 200);
			}
		}
	}
}
// give zeus
public Action GiveItem(Handle timer, any:client)
{
	if(ZeusRound)GivePlayerItem(client, "weapon_taser");
}
// give grenade
public Action GrenadeDetonate(Handle event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if(SpecialRound == true && NadeRound == true && StrEqual(name, "hegrenade_detonate"))
	{
		GivePlayerItem(client, "weapon_hegrenade");
		return Plugin_Handled;
	}
	return Plugin_Handled;
}
// From Abner Bhop Plugin
void BhopOn() // turn on bhop
{
	if(g_Game == Engine_CSGO)
	{
		ServerCommand("sv_staminajumpcost 0");
		ServerCommand("sv_staminalandcost 0");
		ServerCommand("sv_staminamax 0");
		ServerCommand("sv_autobunnyhopping 1");		
		ServerCommand("sv_enablebunnyhopping 1");
		ServerCommand("sv_airaccelerate 2000");
	}
	else
	{
		ServerCommand("sv_enablebunnyhopping 1");
		ServerCommand("sv_airaccelerate 2000");
	}
}
void BhopOff() // turn off bhop
{
	if(g_Game == Engine_CSGO)
	{
		SetDefaultValue("sv_staminajumpcost");
		SetDefaultValue("sv_staminalandcost");
		SetDefaultValue("sv_staminamax");
		SetDefaultValue("sv_autobunnyhopping");		
		SetDefaultValue("sv_enablebunnyhopping");
		SetDefaultValue("sv_airaccelerate 12");
	}
	else
	{
		SetDefaultValue("sv_enablebunnyhopping");
		SetDefaultValue("sv_airaccelerate");
	}
}
stock void SetDefaultValue(char[] scvar){
	ConVar cvar = FindConVar(scvar);
	if(cvar == INVALID_HANDLE)
		return;
		
	char szDefault[100];
	cvar.GetDefault(szDefault, sizeof(szDefault));
	SetConVarString(cvar, szDefault, true);
}
// Knife Can't damage in Special Rounds
public Action OnTakeDamage(victim, &attacker, &inflictor, float &damage, &damagetype)
{
	if(sAllowKnife.BoolValue)
	{
		if(SpecialRound && !BhopRound && !KnifeRound && roundstart == 1)
		{
			RoundFloat(damage);
			char sWeapon[32];
			char sWeapon1[32];
			GetClientWeapon(attacker, sWeapon, sizeof(sWeapon));
			GetClientWeapon(inflictor, sWeapon1, sizeof(sWeapon1));
			if(StrContains(sWeapon, "knife", false) != -1 || (StrContains(sWeapon, "bayonet", false) != -1) || StrContains(sWeapon1, "hegrenade", false) != -1)
			{
				CPrintToChat(attacker,"%t %t", "Tag", "cantknife"); // Message to Attacker
				CPrintToChat(victim,"%t %t", "Tag", "cantknife1"); // Message to Victim
				damage = 0.0;
				return Plugin_Changed;
			}
		}
	}
	if(SpecialRound == true && !BhopRound) // No Fall Damage in Special Round
	{
		if(damagetype == DMG_FALL || attacker == 0 && !sFallDamage.BoolValue)
		{
			damage = 0.0;
			return Plugin_Changed;
		}
		if(0 < attacker <= MaxClients && victim == attacker && !sSelfDamage.BoolValue)
		{
			return Plugin_Handled;
		}
		if(DeagleRound || RevolverRound || ScoutRound || AkRound && roundstart == 1) // Headshot Only
		{
			if(damagetype & CS_DMG_HEADSHOT)
			{
				damage = float(GetClientHealth(victim) + GetClientArmor(victim)); // Kill enemy in One Shot
				return Plugin_Changed;
			}
			else
			{
				damage = 0.0;
				return Plugin_Changed;
			}
		}
	}
	return Plugin_Continue;
}
public Action Event_PlayerHurt(Handle event, const char[] name, bool dontBroadcast)
{
	// For Special Round End Stats
	if(SpecialRound)
	{
		int attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
		if(attacker == 0)
		{
			return;
		}
		int victim = GetClientOfUserId(GetEventInt(event, "userid"));
		if(GetClientTeam(attacker) != GetClientTeam(victim))
		{
			float dmg = GetEventFloat(event, "dmg_health");
			damage1[attacker] += dmg;
			hits[attacker]++;
		}
	}
}
// for Special Round End Stats
public Event_PlayerDeath(Handle event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	int attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	alivect = 0, alivet = 0;
	for (new i = 1; i <= GetMaxClients(); i++)
    {
    	int team;
    	if (IsClientInGame(i) && IsPlayerAlive(i))
   		{
    		team = GetClientTeam(i);
    		if (team == 3) {alivect++;}
        	else if (team == 2) {alivet++;}
		}
    }
	if (alivect == 1 && alivet == 1 && SpecialRound && !BhopRound && sBeacon.BoolValue)
    {
    	SetIDs();
    	CPrintToChatAll("%t {darkred}1 {gold}vs {darkblue}1 {green}Condition Matched! {orchid}Turning {green}ON {darkred}Beacon {orchid}on both players", "Tag");
        CreateBeacon(ctid);
        CreateBeacon(tid);
    }
	if(attacker == 0)
	{
		return;
	}
	int victim = GetClientOfUserId(GetEventInt(event, "userid"));
	if(GetClientTeam(attacker) != GetClientTeam(victim))
	{
		kills[attacker]++;
		if(GetEventBool(event, "headshot"))
		{
			hs[attacker]++;
		}
		char weapon[13];
		GetEventString(event, "weapon", weapon, sizeof(weapon));
		if(StrEqual(weapon, "knife"))
		{
			knives[attacker]++;
		}
		if(StrEqual(weapon, "hegrenade"))
		{
			grenade[attacker]++;
		}
	}
	if(sDissolve.BoolValue && SpecialRound && !BhopRound)
	{
		CreateTimer(2.0 , Dissolve, client);
	}
}
public Action Dissolve(Handle timer, any:client)
{
	if(!IsValidEntity(client)){return;}
	int ragdoll = GetEntPropEnt(client, Prop_Send, "m_hRagdoll");
	char dname[32];
	char dtype[32];
	Format(dname, sizeof(dname), "dis_%d", client);
	Format(dtype, sizeof(dtype), "%d", 2);
	int ent = CreateEntityByName("env_entity_dissolver");
	if (ent>0)
	{
		DispatchKeyValue(ragdoll, "targetname", dname);
		DispatchKeyValue(ent, "dissolvetype", dtype);
		DispatchKeyValue(ent, "target", dname);
		AcceptEntityInput(ent, "Dissolve");
		AcceptEntityInput(ent, "kill");
  	}
}	
stock bool IsClientValid(int client)
{
	if(!(1 <= client <= MaxClients) || !IsClientInGame(client) || !IsClientConnected(client) || IsFakeClient(client) || IsClientSourceTV(client))
		return false;
	return true;
}
// slay player or put player in to spectrator if player join team during Special Round
public Action KillPlayer(Handle timer, any:client)
{
    if (IsClientInGame(client) && IsPlayerAlive(client))
    {
        if (SpecialRound == false)
        {
            return;
        }
        if ((sRemoveNewPlayer.IntValue == 1) && SpecialRound)
        {
            ChangeClientTeam(client, 1);
            CPrintToChat(client, "%t {orchid}You {darkred}Can't {lime}join Team {gold}during {green}Special Round{darkred}!'", "Tag");
            RemoveAllWeapons();
            return;
        }
        CPrintToChat(client, "%t {darkred}SLAYED {orchid}: {lime}Joining Team {gold}during {green}Special Round {pruple}is {darkred}not Allowed!'", "Tag");
        ForcePlayerSuicide(client);
    }
}
RemoveAllWeapons()
{
    int maxent = GetMaxEntities();
    char weapon[64];
    for (new i=MaxClients;i<maxent;i++)
    {
        if ( IsValidEdict(i) && IsValidEntity(i) && GetEntDataEnt2(i, g_Weapon) == -1 )
        {
            GetEdictClassname(i, weapon, sizeof(weapon));
            if (    StrContains(weapon, "weapon_") != -1                // remove weapons
                    || StrEqual(weapon, "hostage_entity", true)         // remove hostages
                    || StrContains(weapon, "item_") != -1           )   // remove bombs
            {
                RemoveEdict(i);
            }
        }
    }
}
void SetIDs()
{
	for (int  i = 1; i <= MaxClients; i++)
	{
		if(IsClientInGame(i) && IsPlayerAlive(i))
		{
			if(GetClientTeam(i) == 2)
			{
				tid = i;
			}
			else if(GetClientTeam(i) == 3)
			{
				ctid = i;
			}
		}
	}
}
public OnConvarChanged(ConVar convar, const char[] oldValue, const char[] newValue)
{
	if(convar == sFunRoundsEnabled){if(convar.BoolValue){sFunRoundsEnabled.BoolValue = true;CPrintToChatAll("%t Plugin is now Enabled!", "Tag");}else{sFunRoundsEnabled.BoolValue = false;CPrintToChatAll("%t Plugin is now Disabled!", "Tag");}}
	if(convar == sEnabledKnife){if(convar.BoolValue){g_activeRoundList.PushString("Round_Knife");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Knife");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sEnabledAwp){if(convar.BoolValue){g_activeRoundList.PushString("Round_Awp");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Awp");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sEnabledZeus){if(convar.BoolValue){g_activeRoundList.PushString("Round_Zeus");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Zeus");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sEnabledDeagle){if(convar.BoolValue){g_activeRoundList.PushString("Round_Deagle");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Deagle");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sEnabledScout){if(convar.BoolValue){g_activeRoundList.PushString("Round_Scout");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Scout");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sEnabledNegav){if(convar.BoolValue){g_activeRoundList.PushString("Round_Negav");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Negav");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sEnabledShotgun){if(convar.BoolValue){g_activeRoundList.PushString("Round_Shotgun");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Shotgun");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sEnabledAutoSniper){if(convar.BoolValue){g_activeRoundList.PushString("Round_AutoSniper");}else{int iRoundPosition = g_activeRoundList.FindString("Round_AutoSniper");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sEnabledAK){if(convar.BoolValue){g_activeRoundList.PushString("Round_AK");}else{int iRoundPosition = g_activeRoundList.FindString("Round_AK");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sEnabledBhop){if(convar.BoolValue){g_activeRoundList.PushString("Round_Bhop");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Bhop");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sEnabledNade){if(convar.BoolValue){g_activeRoundList.PushString("Round_Nade");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Nade");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sEnabledRevolver){if(convar.BoolValue){g_activeRoundList.PushString("Round_Revolver");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Revolver");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sRandomPistols){if(convar.BoolValue){g_activeRoundList.PushString("Round_Pistols");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Pistols");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sRandomRifles){if(convar.BoolValue){g_activeRoundList.PushString("Round_Rifles");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Rifles");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sRandomShotgun){if(convar.BoolValue){g_activeRoundList.PushString("Round_Shotguns");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Shotguns");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sRandomSmgs){if(convar.BoolValue){g_activeRoundList.PushString("Round_Smgs");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Smgs");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sShield){if(convar.BoolValue){g_activeRoundList.PushString("Round_Shield");}else{int iRoundPosition = g_activeRoundList.FindString("Round_Shield");if(iRoundPosition != -1){g_activeRoundList.Erase(iRoundPosition);}}}
	if(convar == sBulletTracers){if(convar.BoolValue){sBulletTracers.BoolValue = true;}else{sBulletTracers.BoolValue = false;}}
	if(convar == sAllowKnife){if(convar.BoolValue){sAllowKnife.BoolValue = true;}else{sAllowKnife.BoolValue = false;}}
	if(convar == sEnableAlert){if(convar.BoolValue){sEnableAlert.BoolValue = true;}else{sEnableAlert.BoolValue = false;}}
	if(convar == sBuyZone){if(convar.BoolValue){sBuyZone.BoolValue = true;}else{sBuyZone.BoolValue = false;}}
	if(convar == sFallDamage){if(convar.BoolValue){sFallDamage.BoolValue = true;}else{sFallDamage.BoolValue = false;}}
	if(convar == sInfiniteAmmo){if(convar.BoolValue){sInfiniteAmmo.BoolValue = true;}else{sInfiniteAmmo.BoolValue = false;}}
	if(convar == sDissolve){if(convar.BoolValue){sDissolve.BoolValue = true;}else{sDissolve.BoolValue = false;}}
	if(convar == sArmor){if(convar.BoolValue){sArmor.BoolValue = true;}else{sArmor.BoolValue = false;}}
	if(convar == sBeacon){if(convar.BoolValue){sBeacon.BoolValue = true;}else{sBeacon.BoolValue = false;}}
	if(convar == sHealthShot){if(convar.BoolValue){sHealthShot.BoolValue = true;}else{sHealthShot.BoolValue = false;}}
	if(convar == sEnableStats){if(convar.BoolValue){sEnableStats.BoolValue = true;}else{sEnableStats.BoolValue = false;}}
	if(convar == sMinPlayers){sMinPlayers.IntValue = StringToInt(newValue);}
	if(convar == sFreezeTime){sFreezeTime.IntValue = StringToInt(newValue);}
}
stock void FilterActiveRounds()
{
	if(!sFunRoundsEnabled.BoolValue){return;}
	g_activeRoundList = new ArrayList(ByteCountToCells(30));
	if(sShield.BoolValue){g_activeRoundList.PushString("Round_Shield");}
	if(sEnabledZeus.BoolValue){g_activeRoundList.PushString("Round_Zeus");}
	if(sEnabledDeagle.BoolValue){g_activeRoundList.PushString("Round_Deagle");}
	if(sEnabledScout.BoolValue){g_activeRoundList.PushString("Round_Scout");}
	if(sEnabledAwp.BoolValue){g_activeRoundList.PushString("Round_Awp");}
	if(sEnabledKnife.BoolValue){g_activeRoundList.PushString("Round_Knife");}
	if(sEnabledNade.BoolValue){g_activeRoundList.PushString("Round_Nade");}
	if(sRandomPistols.BoolValue){g_activeRoundList.PushString("Round_Pistols");}
	if(sRandomRifles.BoolValue){g_activeRoundList.PushString("Round_Rifles");}
	if(sRandomShotgun.BoolValue){g_activeRoundList.PushString("Round_Shotguns");}
	if(sRandomSmgs.BoolValue){g_activeRoundList.PushString("Round_Smgs");}
	if(sEnabledRevolver.BoolValue){g_activeRoundList.PushString("Round_Revolver");}
	if(sEnabledNegav.BoolValue){g_activeRoundList.PushString("Round_Negav");}
	if(sEnabledAK.BoolValue){g_activeRoundList.PushString("Round_AK");}
	if(sEnabledAutoSniper.BoolValue){g_activeRoundList.PushString("Round_AutoSniper");}
	if(sEnabledShotgun.BoolValue){g_activeRoundList.PushString("Round_Shotgun");}
	if(sEnabledBhop.BoolValue){g_activeRoundList.PushString("Round_Bhop");}
}
stock void PerformDeagleRound(){DeagleRound = true;}
stock void PerformShieldRound(){ShieldRound = true;}
stock void PerformKnifeRound(){KnifeRound = true;}
stock void PerformScoutRound(){ScoutRound = true;}
stock void PerformAwpRound(){AwpRound = true;}
stock void PerformZeusRound(){ZeusRound = true;}
stock void PerformNadeRound(){NadeRound = true;}
stock void PerformBhopRound(){BhopRound = true;}
stock void PerformNegavRound(){NegavRound = true;}
stock void PerformAutoSniperRound(){AutoSniperRound = true;}
stock void PerformAKRound(){AkRound = true;}
stock void PerformRevolverRound(){RevolverRound = true;}
stock void PerformShotgunRound(){ShotgunRound = true;}
stock void PerformShotgunsRound(){RandomShotgunRound = true;}
stock void PerformPistolsRound(){RandomPistolsRound = true;}
stock void PerformRiflesRound(){RandomRiflesRound = true;}
stock void PerformSmgsRound(){RandomSmgsRound = true;}
stock ClientCount() {
    int iClients = 0;

    for (new i = 1; i <= MaxClients; i++) {
        if (IsClientInGame(i) &&  GetClientTeam(i) > 1) {
            iClients++;
        }
    }

    return iClients;
} 
// Round End Texts
void BhopEndText()
{
	CPrintToChatAll("%t", "bhop2");
	CPrintToChatAll("%t %t", "Tag", "bhop1");
	CPrintToChatAll("%t", "bhop2");
	PrintCenterTextAll("Bhop Round End!");
}
void AwpEndText()
{
	CPrintToChatAll("%t", "noscope2");
	CPrintToChatAll("%t %t", "Tag", "noscope1");
	CPrintToChatAll("%t", "noscope2");
	PrintCenterTextAll("Bhop and Noscope Round End!");
}
void KnifeEndText()
{
	CPrintToChatAll("%t", "knife2");
	CPrintToChatAll("%t %t", "Tag", "knife1");
	CPrintToChatAll("%t", "knife2");
	PrintCenterTextAll("Knife+Bhop Round End!");
}
void ScoutEndText()
{
	CPrintToChatAll("%t", "scout2");
	CPrintToChatAll("%t %t", "Tag", "scout1");
	CPrintToChatAll("%t", "scout2");
	PrintCenterTextAll("Scout and Headshot Only Round End!");
}
void AKEndText()
{
	CPrintToChatAll("%t", "ak2");
	CPrintToChatAll("%t %t", "Tag", "ak1");
	CPrintToChatAll("%t", "ak2");
	PrintCenterTextAll("AK+Headshot-Only Round End!");
}
void NegavEndText()
{
	CPrintToChatAll("%t", "negav2");
	CPrintToChatAll("%t %t", "Tag", "negav1");
	CPrintToChatAll("%t", "negav2");
	PrintCenterTextAll("Negav+1000 HP Round End!");
}
void NadeEndText()
{
	CPrintToChatAll("%t", "nade2");
	CPrintToChatAll("%t %t", "Tag", "nade1");
	CPrintToChatAll("%t", "nade2");
	PrintCenterTextAll("Nade Only Round End!");
}
void DeagleEndText()
{
	CPrintToChatAll("%t", "deagle2");
	CPrintToChatAll("%t %t", "Tag", "deagle1");
	CPrintToChatAll("%t", "deagle2");
	PrintCenterTextAll("Deagle+Headshot-Only Round End!");
}
void RevolverEndText()
{
	CPrintToChatAll("%t", "revolver2");
	CPrintToChatAll("%t %t", "Tag", "revolver1");
	CPrintToChatAll("%t", "revolver2");
	PrintCenterTextAll("Revolver+Headshot-Only Round End!");
}
void AutoSniperEndText()
{
	CPrintToChatAll("%t", "autosniper2");
	CPrintToChatAll("%t %t", "Tag", "autosniper1");
	CPrintToChatAll("%t", "autosniper2");
	PrintCenterTextAll("AutoSniper+Noscope+Bhop Round End!");
}
void ShotgunEndText()
{
	CPrintToChatAll("%t", "shotgun2");
	CPrintToChatAll("%t %t", "Tag", "shotgun1");
	CPrintToChatAll("%t", "shotgun2");
	PrintCenterTextAll("Shotgun Round End!");
}
void ZeusEndText()
{
	CPrintToChatAll("%t", "zeus2");
	CPrintToChatAll("%t %t", "Tag", "zeus1");
	CPrintToChatAll("%t", "zeus2");
	PrintCenterTextAll("Zeus and Bhop Round End!");
}
void SmgsEndText()
{
	CPrintToChatAll("%t", "randomsmgs2");
	CPrintToChatAll("%t %t", "Tag", "randomsmgs1");
	CPrintToChatAll("%t", "randomsmgs2");
	PrintCenterTextAll("Random Smgs Round End!");
}
void PistolsEndText()
{
	CPrintToChatAll("%t", "randompistols2");
	CPrintToChatAll("%t %t", "Tag", "randompistols1");
	CPrintToChatAll("%t", "randompistols2");
	PrintCenterTextAll("Random Pistols Round End!");
}
void RiflesEndText()
{
	CPrintToChatAll("%t", "randomrifles2");
	CPrintToChatAll("%t %t", "Tag", "randomrifles1");
	CPrintToChatAll("%t", "randomrifles2");
	PrintCenterTextAll("Random Rifles Round End!");
}
void ShotgunsEndText()
{
	CPrintToChatAll("%t", "randomshotguns2");
	CPrintToChatAll("%t %t", "Tag", "randomshotguns1");
	CPrintToChatAll("%t", "randomshotguns2");
	PrintCenterTextAll("Random Shotguns Round End!");
}
void ShieldEndText()
{
	CPrintToChatAll("%t", "shield2");
	CPrintToChatAll("%t %t", "Tag", "shield1");
	CPrintToChatAll("%t", "shield2");
	PrintCenterTextAll("Negav+Shield Round End!");
}

// Round Start Texts
void BhopStartText()
{
	CPrintToChatAll("%t", "bhop2");		
	CPrintToChatAll("%t %t", "Tag", "bhop");
	CPrintToChatAll("%t", "bhop2");
	PrintCenterTextAll("Bhop Round Starts Now!");
}
void AwpStartText()
{
	CPrintToChatAll("%t", "noscope2");		
	CPrintToChatAll("%t %t", "Tag", "noscope");
	CPrintToChatAll("%t", "noscope2");
	PrintCenterTextAll("Noscope and Bhop Round Starts Now!");
}
void KnifeStartText()
{
	CPrintToChatAll("%t", "knife2");		
	CPrintToChatAll("%t %t", "Tag", "knife");
	CPrintToChatAll("%t", "knife2");
	PrintCenterTextAll("Knife and Bhop Round Starts Now!");
}
void AKStartText()
{
	CPrintToChatAll("%t", "ak2");
	CPrintToChatAll("%t %t", "Tag", "ak");
	CPrintToChatAll("%t", "ak2");
	PrintCenterTextAll("AK+Headshot-Only Round Starts Now!");
}
void NegavStartText()
{
	CPrintToChatAll("%t", "negav2");
	CPrintToChatAll("%t %t", "Tag", "negav");
	CPrintToChatAll("%t", "negav2");
	PrintCenterTextAll("Negav+1000 HP Round Starts Now!");
}
void NadeStartText()
{
	CPrintToChatAll("%t", "nade2");
	CPrintToChatAll("%t %t", "Tag", "nade");
	CPrintToChatAll("%t", "nade2");
	PrintCenterTextAll("Nade Only Round Starts Now!");
}
void AutoSniperStartText()
{
	CPrintToChatAll("%t", "autosniper2");
	CPrintToChatAll("%t %t", "Tag", "autosniper");
	CPrintToChatAll("%t", "autosniper2");
	PrintCenterTextAll("AutoSniper+Noscope+Bhop Round Starts Now!");
}
void ScoutStartText()
{
	CPrintToChatAll("%t", "scout2");		
	CPrintToChatAll("%t %t", "Tag", "scout");
	CPrintToChatAll("%t", "scout2");
	PrintCenterTextAll("Scout and Headshot Only Round Starts Now!");
}
void ShotgunStartText()
{
	CPrintToChatAll("%t", "shotgun2");
	CPrintToChatAll("%t %t", "Tag", "shotgun");
	CPrintToChatAll("%t", "shotgun2");
	PrintCenterTextAll("Shotgun Round Starts Now!");
}
void RevolverStartText()
{
	CPrintToChatAll("%t", "revolver2");
	CPrintToChatAll("%t %t", "Tag", "revolver");
	CPrintToChatAll("%t", "revolver2");
	PrintCenterTextAll("Revolver+Headshot Only Round Starts Now!");
}
void DeagleStartText()
{
	CPrintToChatAll("%t", "deagle2");		
	CPrintToChatAll("%t %t", "Tag", "deagle");
	CPrintToChatAll("%t", "deagle2");
	PrintCenterTextAll("Deagle+Headshot Only Round Starts Now!");
}
void ZeusStartText()
{
	CPrintToChatAll("%t", "zeus2");		
	CPrintToChatAll("%t %t", "Tag", "zeus");
	CPrintToChatAll("%t", "zeus2");
	PrintCenterTextAll("Zeus and Bhop Round Starts Now!");
}
void SmgsStartText()
{
	CPrintToChatAll("%t", "randomsmgs2");		
	CPrintToChatAll("%t %t", "Tag", "randomsmgs");
	CPrintToChatAll("%t", "randomsmgs2");
	PrintCenterTextAll("Random Smgs Round Starts Now!");
}
void ShotgunsStartText()
{
	CPrintToChatAll("%t", "randomshotguns2");		
	CPrintToChatAll("%t %t", "Tag", "randomshotguns");
	CPrintToChatAll("%t", "randomshotguns2");
	PrintCenterTextAll("Random Shotgun Round Starts Now!");
}
void RiflesStartText()
{
	CPrintToChatAll("%t", "randomrifles2");		
	CPrintToChatAll("%t %t", "Tag", "randomrifles");
	CPrintToChatAll("%t", "randomrifles2");
	PrintCenterTextAll("Random Rifles Round Starts Now!");
}
void PistolsStartText()
{
	CPrintToChatAll("%t", "randompistols2");		
	CPrintToChatAll("%t %t", "Tag", "randompistols");
	CPrintToChatAll("%t", "randompistols2");
	PrintCenterTextAll("Random Pistols Round Starts Now!");
}
void ShieldStartText()
{
	CPrintToChatAll("%t", "shield2");		
	CPrintToChatAll("%t %t", "Tag", "shield");
	CPrintToChatAll("%t", "shield2");
	PrintCenterTextAll("Negav+Shield Round Starts Now!");
}
// Special Round Status in CHAT
public Action Message(Handle timer)
{
	if(roundstart == 0 || !SpecialRound)return Plugin_Stop;
	if(AwpRound)
	{
		CPrintToChatAll("%t", "noscope2");		
		CPrintToChatAll("%t %t", "Tag", "noscope3");
		CPrintToChatAll("%t", "noscope2");
	}
	if(BhopRound ==  true)
	{	
		CPrintToChatAll("%t", "bhop2");		
		CPrintToChatAll("%t %t", "Tag", "bhop3");
		CPrintToChatAll("%t", "bhop2");
	}
	if(KnifeRound)
	{
		CPrintToChatAll("%t", "knife2");		
		CPrintToChatAll("%t %t", "Tag", "knife3");
		CPrintToChatAll("%t", "knife2");
	}
	if(ZeusRound)
	{
		CPrintToChatAll("%t", "zeus2");		
		CPrintToChatAll("%t %t", "Tag", "zeus3");
		CPrintToChatAll("%t", "zeus2");
	}
	if(DeagleRound)
	{
		CPrintToChatAll("%t", "deagle2");		
		CPrintToChatAll("%t %t", "Tag", "deagle3");
		CPrintToChatAll("%t", "deagle2");
	}
	if(ScoutRound)
	{
		CPrintToChatAll("%t", "scout2");		
		CPrintToChatAll("%t %t", "Tag", "scout3");
		CPrintToChatAll("%t", "scout2");
	}
	if(AkRound)
	{
		CPrintToChatAll("%t", "ak2");		
		CPrintToChatAll("%t %t", "Tag", "ak3");
		CPrintToChatAll("%t", "ak2");
	}
	if(NegavRound)
	{
		CPrintToChatAll("%t", "negav2");		
		CPrintToChatAll("%t %t", "Tag", "negav3");
		CPrintToChatAll("%t", "negav2");
	}
	if(NadeRound)
	{
		CPrintToChatAll("%t", "nade2");		
		CPrintToChatAll("%t %t", "Tag", "nade3");
		CPrintToChatAll("%t", "nade2");
	}
	if(ShotgunRound)
	{
		CPrintToChatAll("%t", "shotgun2");		
		CPrintToChatAll("%t %t", "Tag", "shotgun3");
		CPrintToChatAll("%t", "shotgun2");
	}
	if(AutoSniperRound)
	{
		CPrintToChatAll("%t", "autosniper2");		
		CPrintToChatAll("%t %t", "Tag", "autosniper3");
		CPrintToChatAll("%t", "autosniper2");
	}
	if(RevolverRound)
	{
		CPrintToChatAll("%t", "revolver2");		
		CPrintToChatAll("%t %t", "Tag", "revolver3");
		CPrintToChatAll("%t", "revolver2");
	}
	if(RandomPistolsRound)
	{
		CPrintToChatAll("%t", "randompistols2");		
		CPrintToChatAll("%t %t", "Tag", "randompistols3");
		CPrintToChatAll("%t", "randompistols2");
	}
	if(RandomRiflesRound)
	{
		CPrintToChatAll("%t", "randomrifles2");		
		CPrintToChatAll("%t %t", "Tag", "randomrifles3");
		CPrintToChatAll("%t", "randomrifles2");
	}
	if(RandomSmgsRound)
	{
		CPrintToChatAll("%t", "randomsmgs2");		
		CPrintToChatAll("%t %t", "Tag", "randomsmgs3");
		CPrintToChatAll("%t", "randomsmgs2");
	}
	if(RandomShotgunRound)
	{
		CPrintToChatAll("%t", "randomshotguns2");		
		CPrintToChatAll("%t %t", "Tag", "randomshotguns3");
		CPrintToChatAll("%t", "randomshotguns2");
	}
	if(ShieldRound)
	{
		CPrintToChatAll("%t", "shield2");		
		CPrintToChatAll("%t %t", "Tag", "shield3");
		CPrintToChatAll("%t", "shield2");
	}
	return Plugin_Continue;
}
// Message in hint about round status
public Action MessageHint(Handle timer)
{
	if(roundstart == 0 || !SpecialRound)return Plugin_Stop;
	if(AwpRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Noscope</font><font color='#3DB1FF'>+</font><font color='#FF0000'>Bhop</font> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(BhopRound ==  true )
	{	
		PrintHintTextToAll("<font color='#FF0000'>Bhop <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(KnifeRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Knife</font><font color='#3DB1FF'>+</font><font color='#FF0000'>Bhop</font> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(ZeusRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Zeus</font><font color='#3DB1FF'>+</font><font color='#FF0000'>Bhop</font> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(DeagleRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Deagle</font><font color='#3DB1FF'>+</font><font color='#FF0000'>Headshot Only</font></font><font color='#3DB1FF'>+</font> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(RevolverRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Revolver</font><font color='#3DB1FF'>+</font><font color='#FF0000'>Headshot Only</font></font><font color='#3DB1FF'> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(ScoutRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Scout</font><font color='#3DB1FF'>+</font><font color='#FF0000'>Headshot Only</font> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(AkRound ==  true )
	{	
		PrintHintTextToAll("<font color='#FF0000'>AK-47</font><font color='#3DB1FF'>+</font><font color='#FF0000'>Headshot Only</font></font><font color='#3DB1FF'> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(AutoSniperRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Gaygun</font><font color='#3DB1FF'>+</font><font color='#FF0000'>Noscope</font></font><font color='#3DB1FF'>+</font><font color='#FF0000'>Bhop</font> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(NegavRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Machine Gun</font><font color='#3DB1FF'>+</font><font color='#FF0000'>1000 HP</font> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(NadeRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Grenade Only <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(ShotgunRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Shotgun Only</font><font color='#3DB1FF'> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(RandomPistolsRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Random Pistols</font><font color='#3DB1FF'> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(RandomShotgunRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Random Shotguns</font><font color='#3DB1FF'> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(RandomRiflesRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Random Rifles</font><font color='#3DB1FF'> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(RandomSmgsRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Random SMGs</font><font color='#3DB1FF'> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	if(ShieldRound)
	{
		PrintHintTextToAll("<font color='#FF0000'>Negav</font><font color='#3DB1FF'>+</font><font color='#FF0000'>Shield</font></font><font color='#3DB1FF'> <font color='#3DB1FF'>Round is in progress!</font>");
	}
	return Plugin_Continue;
}
void DownloadableContent()
{
	g_laser = PrecacheModel("materials/sprites/laser.vmt");
	AddFileToDownloadsTable("sound/slayer/Funrounds/zeus.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/bhop.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/round_end.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/knife.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/awp.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/ak.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/machinegun.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/nade.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/scout.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/deagle.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/shotgun.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/autosniper.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/revolver.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/randompistols.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/randomrifles.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/randomshotguns.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/randomsmgs.mp3");
	AddFileToDownloadsTable("sound/slayer/Funrounds/shield.mp3");
	PrecacheSound("slayer/Funrounds/bhop.mp3", true);
	PrecacheSound("slayer/Funrounds/deagle.mp3", true);
	PrecacheSound("slayer/Funrounds/shotgun.mp3", true);
	PrecacheSound("slayer/Funrounds/ak.mp3", true);
	PrecacheSound("slayer/Funrounds/machinegun.mp3", true);
	PrecacheSound("slayer/Funrounds/nade.mp3", true);
	PrecacheSound("slayer/Funrounds/scout.mp3", true);
	PrecacheSound("slayer/Funrounds/autosniper.mp3", true);
	PrecacheSound("slayer/Funrounds/knife.mp3", true);
	PrecacheSound("slayer/Funrounds/zeus.mp3", true);
	PrecacheSound("slayer/Funrounds/round_end.mp3", true);
	PrecacheSound("slayer/Funrounds/awp.mp3", true);
	PrecacheSound("slayer/Funrounds/revolver.mp3", true);
	PrecacheSound("slayer/Funrounds/randompistols.mp3", true);
	PrecacheSound("slayer/Funrounds/randomrifles.mp3", true);
	PrecacheSound("slayer/Funrounds/randomshotguns.mp3", true);
	PrecacheSound("slayer/Funrounds/randomsmgs.mp3", true);
	PrecacheSound("slayer/Funrounds/shield.mp3", true);
}